=== debian/changelog ===
rnp (0.16.0-1) unstable; urgency=medium

  * New upstream version
  * drop patches applied upstream, refresh patches
  * clean up debian/TODO
  * update d/copyright
  * update symbols file

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 26 Mar 2022 13:58:06 -0400
