=== debian/changelog ===
rnp (0.16.2-1mx21+1) mx; urgency=medium

  * Rebuild for MX-21.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 12 Nov 2022 13:47:36 -0800

rnp (0.16.2-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 03 Oct 2022 21:30:25 -0400

rnp (0.16.1-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: bump to 4.6.1 (no changes needed)
  * clean up lintian overrides
  * update symbols file

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 09 Sep 2022 19:02:09 -0400
