## rnp 0.16.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,6 +49,9 @@
   DESCRIPTION "${PACKAGE_DESCRIPTION_SHORT}"
 )
 
+# tri-state options
+set(TRISTATE_VALUES On Off Auto)
+
 # options
 option(ENABLE_COVERAGE "Enable code coverage testing.")
 option(ENABLE_SANITIZERS "Enable ASan and other sanitizers.")
@@ -56,13 +59,16 @@
 option(DOWNLOAD_GTEST "Download Googletest" On)
 option(DOWNLOAD_RUBYRNP "Download ruby-rnp and run related tests." On)
 # crypto components
-option(ENABLE_SM2 "Enable SM2/SM3/SM4 algorithms support." On)
-option(ENABLE_AEAD "Enable AEAD ciphers support." On)
-option(ENABLE_TWOFISH "Enable Twofish cipher support." On)
-option(ENABLE_BRAINPOOL "Enable Brainpool curves support." On)
-
-# tri-state options
-set(TRISTATE_VALUES On Off Auto)
+set(ENABLE_SM2 Auto CACHE STRING "Enable SM2/SM3/SM4 algorithms support.")
+set_property(CACHE ENABLE_SM2 PROPERTY STRINGS ${TRISTATE_VALUES})
+set(ENABLE_AEAD Auto CACHE STRING "Enable AEAD ciphers support.")
+set_property(CACHE ENABLE_AEAD PROPERTY STRINGS ${TRISTATE_VALUES})
+set(ENABLE_TWOFISH Auto CACHE STRING "Enable Twofish cipher support.")
+set_property(CACHE ENABLE_TWOFISH PROPERTY STRINGS ${TRISTATE_VALUES})
+set(ENABLE_BRAINPOOL Auto CACHE STRING "Enable Brainpool curves support.")
+set_property(CACHE ENABLE_BRAINPOOL PROPERTY STRINGS ${TRISTATE_VALUES})
+set(ENABLE_IDEA Auto CACHE STRING "Enable IDEA algorithm support.")
+set_property(CACHE ENABLE_IDEA PROPERTY STRINGS ${TRISTATE_VALUES})
 
 set(ENABLE_DOC Auto CACHE STRING "Enable building documentation.")
 set_property(CACHE ENABLE_DOC PROPERTY STRINGS ${TRISTATE_VALUES})
@@ -92,22 +98,6 @@
   # Default value;
   set(CRYPTO_BACKEND_BOTAN 1)
 elseif(CRYPTO_BACKEND STREQUAL "openssl")
-  # Do not allow OpenSSL backend in release builds yet.
-  if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
-    message(WARNING "OpenSSL backend should be used only at debug mode and not ready for release yet!")
-  endif()
-  # Disable all unsupported features and leave lines below for the future.
-  set(ENABLE_SM2 Off CACHE BOOL "" FORCE)
-  set(ENABLE_AEAD Off CACHE BOOL "" FORCE)
-  set(ENABLE_TWOFISH Off CACHE BOOL "" FORCE)
-  set(ENABLE_BRAINPOOL Off CACHE BOOL "" FORCE)
-  # No SM2 support for OpenSSL yet.
-  if (ENABLE_SM2)
-    message(FATAL_ERROR "OpenSSL backend doesn't support SM2/SM3/SM4 algorithms yet.")
-  endif()
-  if (ENABLE_AEAD)
-    message(FATAL_ERROR "OpenSSL backend doesn't support AEAD ciphers yet.")
-  endif()
   set(CRYPTO_BACKEND_OPENSSL 1)
 else()
   message(FATAL_ERROR "Invalid crypto backend: ${CRYPTO_BACKEND}")
@@ -147,14 +137,6 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 add_definitions(-D_GNU_SOURCE)
-
-if(MSVC_VERSION GREATER_EQUAL "1900")
-    include(CheckCXXCompilerFlag)
-    CHECK_CXX_COMPILER_FLAG("/std:c++latest" _cpp_latest_flag_supported)
-    if (_cpp_latest_flag_supported)
-        add_compile_options("/std:c++latest")
-    endif()
-endif()
 
 if (ENABLE_COVERAGE OR ENABLE_SANITIZERS)
   message("Forcing build type to Debug (for code coverage or sanitizers).")
