=== debian/changelog ===
rnp (0.16.3-1) unstable; urgency=medium

  * New upstream release, Closes: #1034558
    - Fixes CVE-2023-29479
    - Fixes CVE-2023-29480
  * standards-version: bump to 4.6.2 (no changes needed)
  * drop unnecessary lintian overrides
  * d/copyright: include 2023

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 24 May 2023 09:06:07 -0400
