=== debian/rules ===
--- 
+++ 
@@ -30,6 +30,3 @@
 
 %:
 	dh $@ --builddirectory=build
-
-override_dh_strip:
-	dh_strip -a --no-automatic-dbgsym
